part of slang_retail_assistant;

class DefaultAppAction implements RetailAssistantAction {
  late RetailAssistantOnSearchListener? _onSearch;

  void setSearchListener(RetailAssistantOnSearchListener? onSearchListener) {
    _onSearch = onSearchListener;
  }

  @override
  void onAssistantError(Map<String, String> assistantError) {}

  @override
  NavigationAppState onNavigation(NavigationInfo navigationInfo,
      NavigationUserJourney navigationUserJourney) {
    return UnSupportedAppState();
  }

  @override
  OrderManagementAppState onOrderManagement(OrderInfo orderInfo,
      OrderManagementUserJourney orderManagementUserJourney) {
    return UnSupportedAppState();
  }

  @override
  SearchAppState onSearch(
      SearchInfo searchInfo, SearchUserJourney searchUserJourney) {
    if (searchInfo.item?.description == null ||
        searchInfo.item!.description!.isEmpty) {
      if (searchInfo.isAddToCart) {
        return new AddToCartAppState(AddToCartAppState.itemNotSpecified);
      } else {
        return new SearchResultAppState(SearchResultAppState.itemNotSpecified);
      }
    }

    if (_onSearch != null) {
      _onSearch!(searchInfo, searchUserJourney);
    }
    SearchAppState? searchAppState = searchUserJourney.getSearchAppState();

    if (searchAppState == null) {
      if (searchInfo.isAddToCart) {
        searchAppState = new AddToCartAppState(AddToCartAppState.success);
      } else {
        searchAppState = new SearchResultAppState(SearchResultAppState.success);
      }
      try {
        searchUserJourney.notifyAppState(searchAppState);
      } catch (e) {
        print(e);
      }
    }

    return new WaitingAppState();
  }
}
