part of slang_retail_assistant;

class SearchInfo {
  Item? _item;
  late bool _isAddToCart;
  SortingInfo? _sortingInfo;
  List<FilterInfo>? _filterInfoList;
  List<SearchResultInfo>? _searchResultInfoList;
  List<String>? _unrecognizedWordsList;
  late String _searchString;

  Item? get item {
    return _item;
  }

  bool get isAddToCart {
    return _isAddToCart;
  }

  SortingInfo? get sortingInfo {
    return _sortingInfo;
  }

  List<FilterInfo>? get filterInfoList {
    return _filterInfoList;
  }

  List<SearchResultInfo>? get searchResultInfoList {
    return _searchResultInfoList;
  }

  List<String>? get unrecognizedWordsList {
    return _unrecognizedWordsList;
  }

  String get searchString {
    return _searchString;
  }

  SearchInfo._(Map<dynamic, dynamic> map) {
    if (map["item"] != null) {
      _item = Item._(map["item"]);
    }
    _isAddToCart = map["isAddToCart"] ?? false;
    if (map["sortingInfo"] != null) {
      _sortingInfo = SortingInfo._(map["sortingInfo"]);
    } else {
      _sortingInfo = null;
    }
    if (map["filterInfoList"] != null) {
      List<dynamic>? filterInfos = map["filterInfoList"];
      List<FilterInfo> filterInfoListArray = [];
      if (filterInfos != null) {
        for (Map<dynamic, dynamic> filterInfo in filterInfos) {
          filterInfoListArray.add(FilterInfo._(filterInfo));
        }
      }
      _filterInfoList = filterInfoListArray;
    }
    if (map["searchResultInfoList"] != null) {
      List<dynamic>? searchResultInfos = map["searchResultInfoList"];
      List<SearchResultInfo> searchResultInfoListArray = [];
      if (searchResultInfos != null) {
        for (Map<dynamic, dynamic> searchResultInfo in searchResultInfos) {
          searchResultInfoListArray.add(SearchResultInfo._(searchResultInfo));
        }
      }
      _searchResultInfoList = searchResultInfoListArray;
    }
    if (map["unrecognizedWordsList"] != null) {
      List<dynamic>? unrecognizedWords = map["unrecognizedWordsList"];
      List<String> unrecognizedWordsArray = [];
      if (unrecognizedWords != null) {
        for (String unrecognizedWord in unrecognizedWords) {
          unrecognizedWordsArray.add(unrecognizedWord);
        }
      }
      _unrecognizedWordsList = unrecognizedWordsArray;
    }
    _searchString = map["searchString"];
  }

  Map toJson() => {
        'item': _item,
        'isAddToCart': _isAddToCart,
        'filterInfoList': _filterInfoList,
        'sortInfo': _sortingInfo,
        'searchResultInfoList': _searchResultInfoList,
        'unrecognizedWords': _unrecognizedWordsList
      };

  @override
  String toString() {
    return 'SearchInfo{_item: ${_item.toString()}, _isAddToCart: $_isAddToCart, _sortingInfo: $_sortingInfo, _filterInfoList: $_filterInfoList, _searchResultInfoList: $searchResultInfoList, _unrecognizedWords: $unrecognizedWordsList}';
  }
}

class Item {
  String? _description;
  String? _completeDescription;
  String? _id;
  String? _brand;
  String? _productType;
  String? _category;
  String? _subCategory;
  List<String>? _variants;
  List<String>? _productNames;
  Quantity? _quantity;
  Price? _price;
  Size? _size;
  String? _promotionApplied;
  bool? _smartSearch;

  String? get description {
    return _description;
  }

  String? get completeDescription {
    return _completeDescription;
  }

  String? get id {
    return _id;
  }

  String? get brand {
    return _brand;
  }

  String? get productType {
    return _productType;
  }

  String? get category {
    return _category;
  }

  String? get subCategory {
    return _subCategory;
  }

  List<String>? get variants {
    return _variants;
  }

  List<String>? get productNames {
    return _productNames;
  }

  Quantity? get quantity {
    return _quantity;
  }

  Price? get price {
    return _price;
  }

  Size? get size {
    return _size;
  }

  String? get promotionApplied {
    return _promotionApplied;
  }

  bool? get smartSearch {
    return _smartSearch;
  }

  Item._(Map<dynamic, dynamic> map) {
    _description = map["description"];
    _completeDescription = map["completeDescription"];
    _id = map["id"];
    _brand = map["brand"];
    _productType = map["productType"];
    _category = map["category"];
    _subCategory = map["subCategory"];
    List<String> variantsString = [];
    List<dynamic>? variantList = map["variants"];
    if (variantList != null) {
      for (String variant in variantList) {
        variantsString.add(variant);
      }
    }
    _variants = variantsString;
    List<String> productNamesString = [];
    List<dynamic>? productNames = map["productNames"];
    if (productNames != null) {
      for (String productName in productNames) {
        productNamesString.add(productName);
      }
    }
    _productNames = productNamesString;
    if (map["quantity"] != null) {
      _quantity = Quantity._(map["quantity"]);
    }
    if (map["size"] != null) {
      _size = Size._(map["size"]);
    }
    if (map["price"] != null) {
      _price = Price._(map["price"]);
    }
    _promotionApplied = map["promotionApplied"];
    _smartSearch = map["smartSearch"];
  }

  Map toJson() => {
        if (_description != null) 'description': _description,
        if (_description != null) 'completeDescription': _completeDescription,
        if (_id != null) 'id': _id,
        if (_brand != null) 'brand': _brand,
        if (_productType != null) 'productType': _productType,
        if (_category != null) 'category': _category,
        if (_subCategory != null) 'subCategory': _subCategory,
        if (_variants != null) 'variants': _variants,
        if (_productNames != null) 'productNames': _productNames,
        if (_quantity != null) 'quantity': _quantity,
        if (_size != null) 'size': _size,
        if (_price != null) 'price': _price,
        'promotionApplied': _promotionApplied,
        'smartSearch': _smartSearch
      };

  @override
  String toString() {
    return 'Item{_description: $_description, _completeDescription: $_completeDescription, _id: $_id, _brand: $_brand, _productType: $_productType, _category: $_category, _subCategory: $_subCategory, _variants: $_variants, _quantity: $_quantity, _price: $_price, _size: $_size, _promotionApplied: $_promotionApplied, _smartSearch: $_smartSearch}';
  }
}

class Quantity {
  late int _amount;
  late String _unit;

  int get amount {
    return _amount;
  }

  String get unit {
    return _unit;
  }

  Quantity._(Map<dynamic, dynamic> map) {
    _amount = map["amount"];

    var unit = map['unit'] ?? "";
    this._unit = unit.toString().toLowerCase();
  }

  @override
  String toString() {
    return amount.toString() + " " + _unit;
  }

  Map toJson() => {'amount': _amount, 'unit': _unit.toString()};
}

class Size {
  late int _amount;
  late String _unit;

  int get amount {
    return _amount;
  }

  String get unit {
    return _unit;
  }

  Size(this._amount, this._unit);

  Size._(Map<dynamic, dynamic> map) {
    _amount = map["amount"];

    var unit = map['unit'] ?? "";
    _unit = unit.toString().toLowerCase();
  }

  @override
  String toString() {
    return amount.toString() + " " + _unit;
  }

  Map toJson() => {'amount': _amount, 'unit': _unit.toString()};
}

class Price {
  late int _minAmount;
  late int _maxAmount;
  late PriceCurrency _currency;

  int get minAmount {
    return _minAmount;
  }

  int get maxAmount {
    return _maxAmount;
  }

  PriceCurrency get currency {
    return _currency;
  }

  Price._(Map<dynamic, dynamic> map) {
    _minAmount = map["minAmount"];
    _maxAmount = map["maxAmount"];

    var currency = map['currency'] ?? "";
    switch (currency) {
      case "":
        this._currency = PriceCurrency.UNKNOWN;
        break;
      case "rupees":
        this._currency = PriceCurrency.INR;
        break;
      case "dollars":
        this._currency = PriceCurrency.USD;
        break;
      default:
        this._currency = PriceCurrency.UNKNOWN;
    }
  }

  Map toJson() => {
        'minAmount': _minAmount,
        'maxAmount': _maxAmount,
        'currency': _currency.toString()
      };
}

enum PriceCurrency { UNKNOWN, INR, USD }

class FilterInfo {
  late String _filterName;
  late String _filterValue;

  String get filterName {
    return _filterName;
  }

  String get filterValue {
    return _filterValue;
  }

  FilterInfo._(Map<dynamic, dynamic> map) {
    _filterName = map["filterName"];
    _filterValue = map["filterValue"];
  }

  Map toJson() => {'filterName': _filterName, 'filterValue': _filterValue};
}

class SearchResultInfo {
  late String _searchResultValue;
  late String _searchResultId;

  String get searchResultValue {
    return _searchResultValue;
  }

  String get searchResultId {
    return _searchResultId;
  }

  SearchResultInfo._(Map<dynamic, dynamic> map) {
    _searchResultValue = map["searchResultValue"];
    _searchResultId = map["searchResultId"];
  }

  Map toJson() => {
        'searchResultValue': _searchResultValue,
        'searchResultId': _searchResultId
      };
}

class SortingInfo {
  late SortType _sortType;
  late SortOrder _sortOrder;

  SortType get sortType {
    return _sortType;
  }

  SortOrder get sortOrder {
    return _sortOrder;
  }

  SortingInfo._(Map<dynamic, dynamic> map) {
    var sortType = map['sortType'] ?? "";
    switch (sortType) {
      case "unknown":
        this._sortType = SortType.UNKNOWN;
        break;
      case "relevance":
        this._sortType = SortType.RELEVANCE;
        break;
      case "popularity":
        this._sortType = SortType.POPULARITY;
        break;
      case "price":
        this._sortType = SortType.PRICE;
        break;
      case "recommendation":
        this._sortType = SortType.RECOMMENDATION;
        break;
      case "discount":
        this._sortType = SortType.DISCOUNT;
        break;
      case "newness":
        this._sortType = SortType.NEWNESS;
        break;
      default:
        this._sortType = SortType.UNKNOWN;
    }

    var sortOrder = map['sortOrder'] ?? "";
    switch (sortOrder) {
      case "unknown":
        this._sortOrder = SortOrder.UNKNOWN;
        break;
      case "ascending":
        this._sortOrder = SortOrder.ASCENDING;
        break;
      case "descending":
        this._sortOrder = SortOrder.DESCENDING;
        break;
      default:
        this._sortOrder = SortOrder.UNKNOWN;
    }
  }

  Map toJson() =>
      {'sortType': _sortType.toString(), 'sortOrder': _sortOrder.toString()};
}

enum SortType {
  UNKNOWN,
  RELEVANCE,
  POPULARITY,
  PRICE,
  RECOMMENDATION,
  DISCOUNT,
  NEWNESS
}

enum SortOrder { UNKNOWN, ASCENDING, DESCENDING }
