part of slang_retail_assistant;

class SlangConvaTrigger extends StatefulWidget {
  final AssetImage? imageAsset;
  final IconData? icon;
  final Color? iconColor;
  final Color? backgroundColor;
  final bool enableCircularBackground;

  SlangConvaTrigger(
      {this.imageAsset,
      this.icon,
      this.iconColor,
      this.backgroundColor,
      this.enableCircularBackground = false});

  @override
  State<StatefulWidget> createState() => _SlangConvaTriggerState();
}

class _SlangConvaTriggerState extends State<SlangConvaTrigger> {
  @override
  Widget build(BuildContext context) {
    return GestureDetector(
      onTap: () {
        SlangRetailAssistant.startConversation(AssistantUserJourney.SEARCH);
      },
      child: Container(
        width: 50,
        height: 50,
        decoration: widget.enableCircularBackground
            ? BoxDecoration(
                shape: BoxShape.circle,
                color: widget.backgroundColor ?? Colors.black,
              )
            : null,
        child: Center(
          child: LayoutBuilder(
            builder: (context, constraints) {
              double iconSize = constraints.biggest.shortestSide * 0.7;
              return widget.imageAsset != null
                  ? Image.asset(
                      widget.imageAsset!.assetName,
                      width: iconSize,
                      height: iconSize,
                    )
                  : Icon(
                      widget.icon ?? Icons.mic,
                      color: widget.iconColor ?? Colors.white,
                      size: iconSize,
                    );
            },
          ),
        ),
      ),
    );
  }
}
